#!/usr/bin/perl
# $Id: cleanup.pl

use lib '/usr/sausalito/perl';
use SWUpdate;
use CCE;

my $localedir = '/usr/share/locale';

my $cce = new CCE;
$cce->connectfd();

my $obj = $cce->event_old();

my $vendor = $obj->{vendor};
my $name = $obj->{name};
my $version = $obj->{version};

my @oids = $cce->find('Package', { name => $obj->{name}, vendor => $obj->{vendor}, version => $obj->{version} } );

# only delete if we're the last object with this identity
if ($#oids > 0) {
    $cce->bye('SUCCESS');
    exit 0;
}

# delete install directories if they exist.
swupdate_rmunpacked($obj->{location});
if ($vendor and $name and $version) {
    # delete splash stuff
    my $splashdir = swupdate_splashdir($vendor, $name, $version);
    `rm -rf $splashdir`;
    
    # delete locale files
    my $localename = swupdate_localename($vendor, $name, $version);
    `find $localedir -type f -name $localename.mo | xargs rm -f`;

    # delete uninstall scripts
    my $scriptdir = swupdate_scriptdir($vendor, $name, $version);
    `rm -rf $scriptdir`;
}
$cce->bye('SUCCESS');
exit 0;

# 
# Copyright (c) 2016 Michael Stauber, SOLARSPEED.NET
# Copyright (c) 2016 Team BlueOnyx, BLUEONYX.IT
# Copyright (c) 2003 Sun Microsystems, Inc. 
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 